Attribute VB_Name = "Module2"
Public p(1 To 5) As Double, B(1 To 3) As Double, c(1 To 10) As Double
Public f(1 To 4)  As Double
Public po(1 To 4, 1 To 4)  As Double
Public fx(1 To 4)  As Double
Public dteor(1 To 3), DKUI(1 To 3) As Double
Public HMIT As Double
Rem Dim hptab(1 To 3), vtab(1 To 5) As Double

Rem Yo. muuttujat ovat FORTRAN-version COMMON-alueen muuttujia,
Rem siis kaikille aliohjelmille yhteisi.

Sub aitken(f() As Double, po() As Double, fx() As Double, ByVal x As Double, m As Integer, z As Double)
Dim k As Integer

For k = 1 To m
 po(k, 1) = f(k)
Next k

For i = 1 To m - 1
 For k = i + 1 To m
  po(k, i + 1) = ((fx(k) - x) * po(i, i) - (fx(i) - x) * po(k, i)) / (fx(k) - fx(i))
Next k, i

z = po(m, m)

End Sub

Function akant1(ByVal ipl As Integer, ByVal d As Double, ByVal h As Double) As Double

Rem akant1 = Kannon pituus (m), puulajit 1-7
Rem D      = kuorellinen lpimitta (cm)
Rem H      = puun pituus (m)
Rem Funktion arvo on vhintn 0.07 (m) Paitsi, elleivt sytetiedot ole
Rem sallituissa rajoissa, jolloin akant1 = 0.
Rem

Dim g, GA As Double

If (ipl < 1 Or ipl > 7) Then msg = " Kannonkorkeuden ennustaminen ei onnistu, puulaji " & Str$(ipl): MsgBox (msg): GoTo 805
If (d < 0.1 Or d > 85#) Then msg = " Kannonkorkeuden ennustaminen ei onnistu, lpimitta " & Str$(d): MsgBox (msg): GoTo 805
If (h < 1# Or h > 40#) Then msg = " Kannonkorkeuden ennustaminen ei onnistu, pituus " & Str$(h): MsgBox (msg): GoTo 805

Select Case ipl
    
    Case 7     ' LEHTIKUUSI
    g = 0.803156 * h + 0.101395 * d
    Case 6     ' LEPP
    g = 0.7168 * d + 0.016653 * h
    Case 5     ' HAAPA
    GA = 0.509136 + 0.840372 * Log(d)
    g = Exp(GA) - 1
    Case 1     ' MNTY
    g = 0.09522 * h + 0.4456 * d
    Case 2     ' KUUSI
    g = 0.56 * h + 0.5089 * d
    Case 3, 4  ' KOIVUT
    g = 0.497936 * h + 0.4862 * d
    End Select

    akant1 = g / 100#
    GoTo 806

805 akant1 = 0#
    msg = " ALIOHJELMAN AKANT1 ARGUMENTEISSA (KANNONKORKEUS) VIRHE": MsgBox (msg)


806 ' MsgBox ("Kannonkorkeus" & CStr(g / 100#))
End Function

Sub cpoly3(p() As Double, B() As Double)

Rem Ohjelma laskee korjauspolynomin Y = B(1) * X + B(2)*X^2 + B(3)*X^3
Rem kertoimet siten, ett polynomi kulkee seuraavan neljn pisteen kautta:

Rem X1   =   P(1)  =  (H-1.3)/H      rinnankorkeus  Y(X1) = 0
Rem X2   =   P(2)  =  (H-6.0)/H      kuusi metri   Y(X2) = P(3) = DIF
Rem X3   =   P(4)                    tukipiste      Y(X3) = P(5)
Rem X4   =   0                       latva          Y(X4) = 0

Dim CON1, CON2 As Double

CON1 = p(3) / (p(2) * (p(2) - p(1)))
CON2 = p(5) / (p(4) * (p(4) - p(1)))

B(3) = (CON1 - CON2) / (p(2) - p(4))
B(2) = CON1 - B(3) * (p(1) + p(2))
B(1) = p(1) * (p(2) * B(3) - CON1)

End Sub

Sub crk(ByVal ipl As Integer, ByVal d As Double, ByVal d6 As Double, ByVal h As Double, HMIT As Double, c() As Double)

Rem Aliohjelma tekee runkokyrn ja korjaa sit ennusteyhtliden avulla
Rem ipl = puulaji 1-9
Rem d   = rinnankorkeuslpimitta [cm]
Rem d6  = lpimitta kuuden metrin korkeudella [cm]
Rem h   = puun pituus [m]
Rem hmit= Mittaustason korkeus maanpinnasta [m], esim. juurenniska
Rem c   = Runkokyrn kertoimet, d 20 %:n korkeudella ja H maanpinnasta

Rem Virhetilanteet
Dim H13, da, h6, d6a As Double, ivir As Integer
Rem ReDim p(1 To 5) As Double

    ivir = 0
    msg = "a"
    If (ipl < 1 Or ipl > 9) Then msg = "Puulaji ei sopiva" & Str$(ipl): MsgBox (msg)
    If (d < 0.1 Or d > 90#) Then msg = "lpimitta ei sallittu" & Str$(d): MsgBox (msg)
    If (d6 < 0# Or d6 > d + 1#) Then msg = " yllpimitassa vikaa" & Str$(d6): MsgBox (msg)
    If (h < 1.4 Or h > 40#) Then msg = " pituus ei sallittu " & Str$(h): MsgBox (msg)
    If (HMIT < 0 Or HMIT > 1#) Then msg = " mittauskorkeus ?" & Str$(HMIT): MsgBox (msg)
    If (msg <> "a") Then
      MsgBox "Aliohjelmassa CRK (runkokyrn teko ja korjaus) on virhe"
      GoTo 90
     End If

Rem Apusuureet, peruskertoimet, c(9) ja c(10)
    da = d
    H13 = 1.3
    If (HMIT >= 0.01 And h >= 1.5) Then H13 = H13 + HMIT                   ' rinnankorkeus maasta
     Call crkpk(ipl, c())                                                    ' haetaan peruskertoimet c(1) - c(8)
     c(10) = h + HMIT                                                      ' puun pituus maasta
     c(9) = d / crkt(H13, c())
     If (d6 > 0# And h > 6.1) Then GoTo 20                                   ' Jos puulle on mitattu d6 ja pituus on yli 6.1 m kytetn korjausvektorin P laskentaan (d,d6 ja h)

Rem Korjausvektori P (d,h) perusteella, kun puulaji on mnty, kuusi, koivu

    If (ipl > 4) Then GoTo 91
    If (HMIT >= 0.01) Then da = c(9) * crkt(1.3, c())
    Call crkkd(ipl, da, c(), p())
    GoTo 9

Rem Korjausvektori P d:n, d6:n ja h:n perusteella, IPL<=9

20  h6 = 6# + HMIT
    d6a = d6
    If (HMIT < 0.01) Then GoTo 2
    da = c(9) * crkt(1.3, c())
    d6a = (d6 / crkt(h6, c())) * crkt(6#, c())
2   p(1) = 1# - H13 / c(10)
    p(2) = 1# - h6 / c(10)
    p(3) = (d6 / c(9)) - crkt(h6, c())
    
    Call crkkd6(ipl, da, d6a, HMIT, c(), p())

Rem Runkokyrn kertoimien muutokset

9   Call cpoly3(p(), B())

    For i = 1 To 3
     c(i) = c(i) + B(i)
    Next i
     c(9) = d / crkt(H13, c())

     GoTo 91

90  ' Virheilmoitus annettu ohitettiin CRK
    
    For i = 1 To 9     ' Nollataan runkokyrn kertoimet
     c(i) = 0
    Next i

91  End Sub

Function crkd(ByVal hx As Double, c() As Double) As Double

Rem Funktio laskee runkokyrlt puun lpimitan korkeudella HX maanpinnan
Rem tasosta. C(1) - C(8) ovat runkokyrn kertoimet, C(9) on lpimitta
Rem (cm) korkeudella 0,2 * h ja C(10) on puun pituus h (m).


If (hx < 0) Then crkd = 0#: GoTo 1006
If (hx > c(10)) Then crkd = 0#: GoTo 1006

Rem Funktio CRKT laskee suhteen CRKD/C(9)

crkd = c(9) * crkt(hx, c())

1006 End Function

Function crkh(ByVal dx As Double, c() As Double) As Double

Rem msg = Str$(dx) & " crkh:ta kutsuttu korkeudelle" & "pituus on " & Str$(c(10)): MsgBox (msg)
Rem Funktio etsii lpimittaa DX vastaavan korkeuden runkokyrlt

Dim h, dr, hr, g, hyppy  As Double
Dim L As Integer

h = c(10)
g = 1#
hyppy = 1#

If (0# > dx Or dx > 85# Or 1.4 > h Or h > 40#) Then msg = " Funktion CRKH argumenteissa virhe lpm:" & Str$(dx) & " pituus:" & Str$(c(10)): MsgBox (msg): crkh = 0#: GoTo 2004

L = h / hyppy
hr = h
If (L * hyppy = h) Then hr = h + 0.01

Rem Haarukoidaan

For i = 1 To L
hr = hr - hyppy
If ((c(9) * crkt(hr, c()) > dx)) Then: GoTo 2002
If (i <> L) Then GoTo 2005
g = -1#
hr = hyppy
2005 Next i

Rem Tarkennus


2002 For i = 1 To 7
       hyppy = hyppy / 2#
       hr = hr + g * hyppy
       dr = c(9) * crkt(hr, c())
Rem    msg = Str$(dr) & " " & Str$(hr): MsgBox (msg)
       If (dr > dx) Then g = 1#
       If (dr <= dx) Then g = -1#
     Next i

crkh = hr

2004 End Function

Sub crkkd(ipl As Integer, ByVal d As Double, c() As Double, p() As Double)

Rem Aliohjelma muodostaa P-vektorin d:n ja h:n avulla laskettavalle
Rem runkokyrlle. Korjauspolynomi B on laskettava siten, ett
Rem B(0)      = 0      Latva
Rem B(P(1))   = 0      0.1 * h
Rem B(P(2))   = P(3)   0.4 * h
Rem B(P(3))   = P(5)   0.7 * h

Rem IPL       on puulaji
Rem D         on rinnankorkeuslpimitta (cm)
Rem C(1)-C(8) on runkokyrn peruskertoimet sisltv vektori
Rem C(10)     on puun pituus (m)

Rem Koska B:n arvo rinnankorkeuslpimittapisteess ei ole nolla,
Rem voidaan C(9) d80 laskea vasta runkokyrkorjauksen jlkeen.
Rem

Dim T1, T4, T7, Y1, Y4, Y7, h, dh2, dl, d2 As Double
Rem ReDim p(1 To 5) As Double, c(1 To 10) As Double

Rem Tarvittavat muuttujat

h = c(10)
dh = d / (h - 1.3)
dh2 = dh ^ 2
dl = Log(d)
hl = Log(h)
d2 = d ^ 2

Rem Lasketaan peruskyrn arvot, T1, T4 ja T7 sek korjaukset
Rem Y1, Y4 ja Y7 korkeuksilla 0.1*h, 0.4*h ja 0.7*h

Select Case ipl

   Case 1    ' Mnty
    T1 = 1.100553
    T4 = 0.8585458
    T7 = 0.5442665

    Y1 = 0.26222 - 0.0016245 * d + 0.010074 * h + 0.06273 * dh - 0.011971 * dh2 - 0.15496 * hl - 0.45333 / h
    Y4 = -0.38383 - 0.0055445 * h - 0.014121 * dl + 0.17496 * hl + 0.62221 / h
    Y7 = -0.179 + 0.037116 * dh - 0.12667 * dl + 0.18974 * hl
    

   Case 2   ' Kuusi
    T1 = 1.0814409
    T4 = 0.8409653
    T7 = 0.4999158

    Y1 = -0.003133 * d + 0.01172 * h + 0.48952 * dh - 0.078688 * dh2 - 0.31296 * dl + 0.13242 * hl - 1.2967 / h
    Y4 = -0.0065534 * d + 0.011587 * h - 0.054213 * dh + 0.011557 * dh2 + 0.12598 / h
    Y7 = 0.084893 - 0.0064871 * d + 0.012711 * h - 0.10287 * dh + 0.026841 * dh2 - 0.01932 * dl
    
   Case 3, 4   ' Koivu
    T1 = 1.084544
    T4 = 0.8417135
    T7 = 0.4577622

    Y1 = 0.59848 + 0.011356 * d - 0.49612 * dl + 0.46137 * hl - 0.92116 / dh + 0.25182 / dh2 - 0.00019947 * d2
    Y4 = -0.96443 + 0.011401 * d + 0.1387 * dl + 1.5003 / h + 0.57278 / dh - 0.18735 / dh2 - 0.00026 * d2
    Y7 = -2.1147 + 0.79368 * dl - 0.5181 * hl + 2.906 / h + 1.6811 / dh - 0.40778 / dh2 - 0.00011148 * d2
    
   End Select

     If (Abs(Y1) < 0.1) Then
      If (Y1 >= 0) Then Y1 = Abs(Y1)
      If (Y1 < 0) Then Y1 = -Abs(Y1)
     End If
     If (Abs(Y1) >= 0.1) Then
      If (Y1 >= 0) Then Y1 = 0.1
      If (Y1 < 0) Then Y1 = -0.1
     End If

     If (Abs(Y4) < 0.1) Then
      If (Y4 >= 0) Then Y4 = Abs(Y4)
      If (Y4 < 0) Then Y4 = -Abs(Y4)
     End If
     If (Abs(Y4) >= 0.1) Then
      If (Y4 >= 0) Then Y4 = 0.1
      If (Y4 < 0) Then Y4 = -0.1
     End If

     If (Abs(Y7) < 0.1) Then
      If (Y7 >= 0) Then Y7 = Abs(Y7)
      If (Y7 < 0) Then Y7 = -Abs(Y7)
     End If
     If (Abs(Y7) >= 0.1) Then
      If (Y7 >= 0) Then Y7 = 0.1
      If (Y7 < 0) Then Y7 = -0.1
     End If

Rem Lasketaan P-vektori. Korjaukset on laskettu oletuksella B(P(1)) = Y1
Rem Koska kuitenkin B(P(1)):n on oltava nolla, on korjaukset tehtv kyrlle,
Rem joka saadaan kertomalla oletuskyr luvulla (T1+Y1)/T1 :

p(1) = 0.9
p(2) = 0.6
p(3) = T1 / (T1 + Y1) * (T4 + Y4) - T4
p(4) = 0.3
p(5) = T1 / (T1 + Y1) * (T7 + Y7) - T7

   

End Sub

Sub crkkd6(ipl As Integer, ByVal d As Double, ByVal d6 As Double, HMIT As Double, c() As Double, p() As Double)

Rem Aliohjelma mr runkokyrn korjauspolynomin apupisteen p(4) sek
Rem korjauspolynomin arvon p(5) apupisteess d:n , d6:n ja h:n perusteella.
Rem IPL         puulaji
Rem D           rinnankorkeuslpimitta (cm)
Rem D6          kuuden metrin lpimitta (cm)
Rem HMIT        mittaustason korkeus maantasalta (m)
Rem C(1) - C(8) runkokyrn peruskertoimet
Rem C(9)        lpimitta korkeudella 0.2*h (d80)
Rem C(10)       puun pituus h.

Rem ReDim p(1 To 5) As Double, c(1 To 10) As Double
Rem Static po(1 To 4, 1 To 4), f(1 To 4), fx(1 To 4)   As Double
Dim xt, t2t, xe, t13, h, hsd, hd, d6d, at, dif, cx, xx, xr, p4iso, p5iso, yy As Double
Rem Lasketaan tarvittavat apusuureet: H, HSD, HD, D6D, AT ja DIF
h = c(10)
hsd = (h - 6#) / d6
hd = (h - 1.3) / d
d6d = (d - d6) / d
at = d6 / c(9)
dif = p(3)
If (HMIT >= 0.01) Then dif = at - crkt(6#, c())

Rem P(4) ja P(5)
Rem P(5):lle on jokaiselle puulajille kolme kaavaa:
Rem Kaavat 11-13 isoille puille > 13.05 m
Rem Kaavat 21-23 pienille puille < 8.35 m
Rem Kun 8.35 =< pituus >= 13.05 lasketaan tulos molempien em. kaavojen perusteella.

If (h < 8.35) Then GoTo 200

Rem Isot puut:

p(4) = 0.5 - 3# / h

      Select Case ipl

      Case 1, 8              ' Mnty
      cx = Abs(h - 10.7) / 9.4
      xx = dif * (1# + cx) * (h + 4#) / (h - 0.7)
      p(5) = -0.3107 + 1.2036 * dif + 0.096447 * hsd + 0.32458 * d6d - 0.16066 * xx + 0.21072 * at

      Case 2                ' Kuusi
      p(5) = -0.51243 + 1.0204 * dif - 0.10077 * hd + 0.19315 * hsd + 0.52327 * d6d + 0.40615 * at

      Case 3, 4, 5, 6, 9    ' Koivu
      p(5) = -0.86846 + 0.61482 * dif + 0.079054 * hd + 0.84701 * d6d + 0.71465 * at

      Case 7                ' Lehtikuusi
      p(5) = -0.719394 + 1.00321 * dif + 0.0825812 * hsd + 0.778782 * d6d + 0.547997 * at

      End Select
      If (h >= 13.05) Then GoTo 209  ' Aliohjelman suoritus loppuu.

      p4iso = p(4)
      p5iso = p(5)

Rem Pienet Puut:

200             ' Thn hypttiin, jos kyseess oli pieni (h < 8.35 m) puu.

      p(4) = 1# - 3.65 / h

      Select Case ipl

      Case 1, 8             ' Mnty, muu havupuu
      p(5) = -0.039003 + 0.39739 * dif + 0.04201 * hd - 0.07917 * hsd + 0.062884 * at

      Case 2                ' Kuusi
      p(5) = -0.037635 + 0.53502 * dif + 0.072073 * hd - 0.065727 * hsd + 0.032871 * at

      Case 3, 4, 5, 6, 9    ' Koivut, lehtipuut
      p(5) = -0.083783 + 0.37229 * dif + 0.097625 * at

      Case 7                ' Lehtikuusi
      cx = Abs(10.7 - h) / 9.4
      xr = dif * (1# + cx)
      xx = 4.7 * xr / (h - 1.3)
      p(5) = 1.10708 - 1.24663 * d6d - 0.739426 * xx - 0.978947 * at + 0.613124 * xr

      End Select

      If (h < 8.35) Then GoTo 300

Rem Keskikokoiset puut:

      fx(1) = p(1): fx(2) = p(2): fx(3) = p4iso: fx(4) = 0#
       f(1) = 0#:    f(2) = dif:   f(3) = p5iso:  f(4) = 0#
      
      tt = (h - 8.35) / 4.7
      If (h > 10.7) Then GoTo 260
      Call aitken(f(), po(), fx(), p(4), 4, yy)
      p(5) = tt * yy + (1# - tt) * p(5)
      GoTo 300

260   fx(3) = p(4): f(3) = p(5): p(4) = p4iso
      Call aitken(f(), po(), fx(), p(4), 4, yy)
      p(5) = tt * p5iso + (1# - tt) * yy

Rem Korjaus mahdollista pullistumaa vastaan vlill 1.3 m, 6 m
300   If (Abs(dif) < 0.15) Then GoTo 209
      t13 = d / c(9)
      xe = crkt(3.65, c())
      If (h > 10.7) Then GoTo 310
      xx = xe + p(5)
      If (xx < t13) Then GoTo 209
      p(5) = 0.5 * (t13 + at) - xe
      GoTo 209

Rem Korjaus mahdollista pullistumaa vastaan, kun 10.7 m < h < 13.05

310  fx(3) = p4iso: f(3) = p(5): t2t = (h - 10.7) / 2.35: xt = 1# - 3.65 / h
     Call aitken(f(), po(), fx(), xt, 4, yy)
     xx = xe + xy
     If (xx < t13) Then GoTo 209
     tx = 0.5 * (t13 + at) - xe
     fx(3) = xt: f(3) = tx
     Call aitken(f(), po(), fx(), p(4), 4, yy)
     p(5) = t2t * p(5) + (1# - t2t) * yy


209 End Sub

Sub crkosa(ByVal ipl As Integer, ByVal imit As Integer, ByVal d As Double, ByVal d6 As Double, ByVal h As Double, ByVal mask As Integer, hptab() As Double, vtab() As Double)

Rem Aliohjelma laskee puun tukki-, kuitu- ja latvahukkaosien tilavuudet,
Rem mahdollisen tyveyksen tilavuuden sek niden osien yhteistilavuuden
Rem puulajin, d:n, d6:n ja h:n perusteella.
Rem
Rem Osien alku- ja pttymiskorkeudet voidaan antaa ohjelmassa, mutta
Rem ellei kaikkia anneta, lasketaan puuttuvat seuraavasti:

Rem Tukkiosan alkukorkeus:       estimoitu juurenniska, vhintn 10 cm
Rem Tukkiosan pttymiskorkeus:  PMP-systeemin plkytysalgoritmi
Rem Kuituosan pttymiskorkeus:  Korkeus, jolla kuoreton lpimitta on
Rem                                                      6,3 cm mnty
Rem                                                      6,5 cm kuusi, koivu
Rem
Rem
Rem Vlitettvt parametrit:
Rem
Rem IPL      Puulaji
Rem IMIT     1, jos maanpinta; 2, jos juurenniskalta
Rem D        rinnankorkeuslpimitta, cm
Rem D6       kuuden metrin lpimitta, cm
Rem H        pituus, m
Rem MASK     Kokonaisluku, joka kertoo, onko annettu pttymis-/alku-korkeuksia
Rem          Muotoa abc
Rem          a = 1    tukkiosan alkukorkeus on annettu
Rem          b = 1    tukkiosan pttymiskorkeus on annettu
Rem          c = 1    kuituosan pttymiskorkeus on annettu
Rem
Rem          Esim. MASK = 0    Ohjelma laskee kaikki korkeudet
Rem                MASK = 110  Ohjelma laskee vain kuituosan pttymiskorkeuden.
Rem
Rem HPTAB    HPTAB(1) tukkiosan alkukorkeus, m
Rem          HPTAB(2) tukkiosan pttymiskorkeus,m
Rem          HPTAB(3) kuituosan pttymiskorkeus, m
Rem          Kutsuttaessa on HPTAB-taulukossa MASK-muuttujan arvon mukainen mr korkeuksia
Rem          Palattaessa taulukossa on kaikki korkeudet.
Rem
Rem          Jollei tukkia ole HPTAB(1) = HPTAB(2)
Rem          Jollei kuitua ole HPTAB(2) = HPTAB(3)
Rem
Rem Tulosparametrit:
Rem
Rem VTAB     VTAB(1)  Tukkiosan tilavuus dm3
Rem          VTAB(2)  Kuituosan tilavuus dm3
Rem          VTAB(3)  Latvahukkaosan tilavuus dm3
Rem          VTAB(4)  Tyveyksen tilavuus dm3
Rem          VTAB(5)  Rungon tilavuus kannolta tai tukkiosan alkokorkeudelta latvaan (minimi)
Rem
Rem Jos syttparametreissa on vikaa, on paluutilanteessa VTAB(i) = 0.0.
Rem HPTAB:ssa on ainakin samat tiedot kuin kutsuttaessa, ehk muutakin.

Dim hjn, hteor, hpmaa, ht, hkui, htod As Double
Dim ntuk As Integer
Rem Dim hptab(1 To 3), vtab(1 To 5) As Double

dteor(1) = 15.5 ' mnty
dteor(2) = 16#  ' kuusi
dteor(3) = 18#  ' koivu
DKUI(1) = 7   ' mnty
DKUI(2) = 7   ' kuusi
DKUI(3) = 7   ' koivu

Rem Nollataan tilavuustaulukko ja tarkistetaan, ett puulaji on sallittu

For i = 1 To 5
 vtab(i) = 0#
Next i

If (ipl < 1 Or ipl > 3) Then GoTo 109 ' Palataan, ellei puulaji kelpaa

Rem Estimoidaan juurenniskan korkeus. Mittausten alkupiste on joko maanpinta
Rem tai juurenniska.

If (imit = 2) Then GoTo 102
  hjn = akant1(ipl, d, h)
  HMIT = 0#
  GoTo 103

102 hjn = hkanio(ipl, d, h)
    HMIT = hjn

Rem Lasketaan runkokyr


103 If (h < 1.31 Or d < 1#) Then
 msg = " Pituus " & Str$(h) & " CRKOSA loppu"
 MsgBox (msg)
 GoTo 109 ' lopetetaan ellei onnistu
End If


Call crk(ipl, d, d6, h, HMIT, c())

If (c(9) = 0#) Then
 msg = " lpimitta 20 %:n korkeudella " & Str$(c(9)) & " CRKOSA loppu"
 MsgBox (msg)
 GoTo 109 ' lopetetaan ellei onnistu
End If

Rem Tukkiosan alkukohdaksi asetetaan juurenniska ( tai 10 cm maanpinnasta,
Rem jos tm on korkeampi) ellei tukkiosan alkukohtaa ole annettu.

If (hjn > 0.1) Then HKAN = hjn - HMIT
If (hjn <= 0.1) Then HKAN = 0.1 - HMIT

If (mask < 100) Then hptab(1) = HKAN

Rem Tukkiosan pttymislpimitta on (ellei sit ole annettu) mrttv
Rem PMP-systeemin plkytysalgoritmilla. Tarkistetaan kuienkin aluksi
Rem ett puu on tyvess niin paksu ett yleens kannattaa yritt
Rem laskea tukkiosaa:

If ((mask Mod 100) >= 10) Then GoTo 1004
hptab(2) = hptab(1)
If (crkd(hjn, c()) < (dteor(ipl) + 1#)) Then GoTo 1004

Rem Lasketaan ensin teoreettinen pttymiskorkeus (I-O). Siit vhennetn
Rem EROEST -funktion antamaa mr ja korjataan saatua tukkiosapituutta siten,
Rem ett saadaan snnnmukaisia plkkyj. Tukkiosa pttyy kuitenkin viimeistn
Rem korkeuteen, jolla lpimitta on teoreettinen pttymislpimitta - 1.33 cm.

hteor = crkh(dteor(ipl), c()) - hjn
hpmaa = hjn + hteor - eroest(ipl, hteor, ntuk)

If (crkd(hpmaa, c()) < (dteor(ipl) - 1.33)) Then hpmaa = crkh(dteor(ipl) - 1.33, c())
ht = hpmaa - (HMIT + hptab(1))

Call polk(ht, htod, ntuk)

hptab(2) = hptab(1) + htod

1004 Rem

Rem Ellei kuituosan pttymiskorkeutta ole annettu, lasketaan se siten, ett
Rem puulla on pttymiskorkeudella tietty lpimitta. Ellei tukkiosaa saatu, on
Rem kuituosan kuitenkin oltava vhintn kaksi metri:

If ((mask Mod 10) <> 0) Then GoTo 1005
hptab(3) = hptab(2)

If (crkd(hjn, c()) <= DKUI(ipl)) Then GoTo 1005
hkui = crkh(DKUI(ipl), c()) - (HMIT + hptab(2))
If (hptab(2) <= hptab(1) And hkui < 2#) Then hkui = 0#
hptab(3) = hptab(2) + hkui

1005 Rem

Rem Jos HPTAB:ssa ei ole ei-laskeva jono, tilavuuksia ei lasketa:

If (hptab(1) > hptab(2) Or hptab(2) > hptab(3) Or hptab(3) > h) Then msg = "HPTAB:ssa ei ole laskeva jono ": MsgBox (msg): GoTo 109

Rem Lasketaan tilavuudet:

If (hptab(1) < hptab(2)) Then vtab(1) = crkv(HMIT + hptab(1), HMIT + hptab(2), c())
If (hptab(2) < hptab(3)) Then vtab(2) = crkv(HMIT + hptab(2), HMIT + hptab(3), c())
vtab(3) = crkv(HMIT + hptab(3), HMIT + h, c())
vtab(4) = crkv(HMIT + HKAN, HMIT + hptab(1), c())
vtab(5) = vtab(1) + vtab(2) + vtab(3) + vtab(4)

109 End Sub

Sub crkpk(ipl As Integer, c() As Double)

Rem Aliohjelma valitsee perusrunkokyrn kertoimet puulajin 'ipl'
Rem perusteella. IPL saa arvoja 1-9. Kertoimet C(1)-C(8) ovat
Rem muuttujille X, X^2, X^3, X^5, X^8, X^13, X^21, X^34.

     Select Case ipl
      Case 1, 8         'Mnty (Pinus sylvestris), muu havupuu
      c(1) = 2.1288
      c(2) = -0.63157
      c(3) = -1.6082
      c(4) = 2.4886
      c(5) = -2.4147
      c(6) = 2.3619
      c(7) = -1.7539
      c(8) = 1.0817
      GoTo 10

      Case 2            'Kuusi (Picea abies)
      c(1) = 2.3366
      c(2) = -3.2684
      c(3) = 3.6513
      c(4) = -2.2608
      c(5) = 0#
      c(6) = 2.1501
      c(7) = -2.7412
      c(8) = 1.8876
      GoTo 10

      Case 3, 4, 9        'Koivut (Betula pendula, Betula pubescens), muu lehtipuu
      c(1) = 0.93838
      c(2) = 4.106
      c(3) = -7.8517
      c(4) = 7.8993
      c(5) = -7.5018
      c(6) = 6.3863
      c(7) = -4.3918
      c(8) = 2.1604
      GoTo 10

      Case 5            'Haapa (Populus tremula)
      c(1) = 1.06
      c(2) = 3.7233
      c(3) = -7.411
      c(4) = 7.3395
      c(5) = -6.7216
      c(6) = 5.9156
      c(7) = -4.3415
      c(8) = 1.9663
      GoTo 10

      Case 6            'Lepp (Alnus incana, Alnus glutinosa)
      c(1) = 1.2862
      c(2) = 1.4068
      c(3) = -2.925
      c(4) = 2.6134
      c(5) = -2.5468
      c(6) = 2.972
      c(7) = -2.7061
      c(8) = 1.5434
      GoTo 10

      Case 7            'Lehtikuusi (Larix sibirica)
      c(1) = 1.9046
      c(2) = 0.49028
      c(3) = -3.472
      c(4) = 4.5721
      c(5) = -4.4098
      c(6) = 3.7186
      c(7) = -2.5256
      c(8) = 1.4112
      GoTo 10
      End Select
10 End Sub

Function crkt(ByVal hx As Double, c() As Double) As Double

Rem Olkoon HX pisteen X etisyys maanpinnan tasosta [m].
Rem Funktio laskee suhteen DX/D80, miss DX on lpimitta pisteess X
Rem ja D80 on lpimitta pisteess, jonka etisyys latvasta on 0.8*H.
Rem C(1) - c(8) ovat runkokyrn kertoimet ja c(10) puun pituus [m].

Dim x, x2, x3, x5, x8, x13, x21, x34 As Double, msg As String

x = (c(10) - hx) / c(10)
 If (x > 1) Then
'  msg = "CRKT: Korkeus " & Str$(hx) & "M <0"
'  MsgBox (msg)
  crkt = 0#
  GoTo 66
 End If
 If (x < 0) Then
'  msg = "CRKT: Korkeus " & Str$(hx) & "M > Puun pituus " & Str$(c10)
'  MsgBox (msg)
  crkt = 0#
  GoTo 66
 End If

 x2 = x * x
 x3 = x * x2
 x5 = x2 * x3
 x8 = x3 * x5
 x13 = x5 * x8
 x21 = x8 * x13
 x34 = x13 * x21

 crkt = c(1) * x + c(2) * x2 + c(3) * x3 + c(4) * x5 + c(5) * x8 + c(6) * x13 + c(7) * x21 + c(8) * x34

66 End Function

Function crkv(ByVal H1 As Double, ByVal H2 As Double, c() As Double) As Double
Static a(1 To 8, 1 To 8) As Double
Static hx(1 To 2), VOL(1 To 2) As Double
Dim x, x2, x3, x5, x8, x13, h As Double, ivir, i, J As Integer

h = c(10)             ' Pituus saa arvon C(10)

Rem Mrtn integroimisrajat HX(1), HX2 siten, ett HX(1) < HX(2)

hx(1) = H1
hx(2) = H2
If (H1 < H2) Then GoTo 1
hx(1) = H2
hx(2) = H1

1 ivir = 0

If (hx(1) < 0#) Then ivir = 1
If (hx(2) > h) Then ivir = ivir + 2
If (ivir > 0) Then MsgBox "VIRHEIT CRK:SSA"

Rem Integeroinnissa tarvitaan kertoimien keskiniset tulot

For i = 1 To 8
 For J = 1 To 8
  a(i, J) = c(i) * c(J)
 Next J, i

      
Rem Lasketaan primitiivifunktion arvot VOL(1) ja VOL(2)
Rem korkeuksia HX(1) ja HX(2) vastaavissa runkokyrpisteiss.
Rem Latvassa X=0 eli HX=H on primitiivifunkition arvo nolla.

For i = 1 To 2
 x = (h - hx(i)) / h
 VOL(i) = 0
 If (x = 0#) Then GoTo 4

 x2 = x * x
 x3 = x * x2
 x5 = x2 * x3
 x8 = x3 * x5
 x13 = x5 * x8

 VOL(i) = (((((((((((((((x13 * a(8, 8) / 69# + a(7, 8) / 28#) * x8 + a(6, 8) / 24#) * x5 + (2# * a(5, 8) + a(7, 7)) / 43#) * x3 + a(4, 8) / 20#) * x2 + a(3, 8) / 19#) * x + a(2, 8) / 18.5) * x + a(1, 8) / 18#) * x + a(6, 7) / 17.5) * x5 + a(5, 7) / 15#) * x3 + (2# * a(4, 7) + a(6, 6)) / 27#) * x2 + a(3, 7) * 0.08) * x + a(2, 7) / 12#) * x + a(1, 7) / 11.5) * x + a(5, 6) / 11#) * x3 + a(4, 6) / 9.5) * x2
 VOL(i) = ((((((((((((((VOL(i) + (2# * a(3, 6) + a(5, 5)) / 17#) * x + a(2, 6) * 0.125) * x + a(1, 6) / 7.5) * x + a(4, 5) / 7#) * x2 + a(3, 5) / 6#) * x + (2# * a(2, 5) + a(4, 4)) / 11#) * x + a(1, 5) * 0.2) * x + a(3, 4) / 4.5) * x + a(2, 4) * 0.25) * x + (2# * a(1, 4) + a(3, 3)) / 7#) * x + a(2, 3) / 3#) * x + (a(1, 3) * 0.4 + a(2, 2) * 0.2)) * x + a(1, 2) * 0.5) * x + a(1, 1) / 3#) * x3

4 Next i
V = VOL(1) - VOL(2)
crkv = 0.078539832 * c(9) ^ 2 * h * V
End Function

Function eroest(ipl As Integer, ByVal hteor As Double, ByVal ntuk As Integer)

Rem Funktio mr keskimriseen latvakuituun siirtyvn tukkiosan pituuden.
Rem IPL        Puulaji
Rem HTEOR      Teoreettisen tukkiosan pituus
Rem NTUK       Tukkien lukumrn estimaatti
Rem
Rem Latvakuituun siirtyvn tukkiosan pituus ja tukkien lukumr
Rem estimoidaan seuraavasti:
Rem
Rem SIIRTYMA = AL (i,ipl) + AK(i,ipl)*hteor
Rem TUKKIEN LKM = i
Rem
Rem Kun P(i-1,ipl) <hteor <= P(i,ipl)
Rem
Rem Kerrointaulukot AL, AK ja P

Dim ero As Double
ReDim AK(1 To 5, 1 To 2), AL(1 To 5, 1 To 2), pa(1 To 4, 1 To 2) As Double

AK(1, 1) = 0.75209: AK(2, 1) = 0.689751: AK(3, 1) = 0.64176: AK(4, 1) = 0.681488: AK(5, 1) = 0.652631
AK(1, 2) = 0.848382: AK(2, 2) = 0.610232: AK(3, 2) = 0.609285: AK(4, 2) = 0.617363: AK(5, 2) = 0.552112

AL(1, 1) = 3.7549:  AL(2, 1) = 6.3858:  AL(3, 1) = 8.79872: AL(4, 1) = 12.4718: AL(5, 1) = 14.829
AL(1, 2) = 4.5159:  AL(2, 2) = 5.74381: AL(3, 2) = 8.45665: AL(4, 2) = 11.3582: AL(5, 2) = 12.4288

pa(1, 1) = 8.12758: pa(2, 1) = 13.0018: pa(3, 1) = 18.1586: pa(4, 1) = 24.4122
pa(1, 2) = 7.94745: pa(2, 2) = 12.8365: pa(3, 2) = 17.3885: pa(4, 2) = 22.1969

Rem Alkuasetukset:

ero = 0#
ntuk = 1

Rem funktion arvo lasketaan vain puulajeille 1 ja 2 , muille eroest = 0.

If (ipl > 3) Then GoTo 1100
If (3 <= ipl <= 4) Then GoTo 1130

Rem Mr tukkien lukumr

For i = 1 To 4
 If (hteor <= pa(i, ipl)) Then GoTo 1120
 ntuk = ntuk + 1
Next i

Rem Eron estimaatti sahalaitafunktiolta
Rem Erosta vhennetn 0,15 m, koska plkytysalgoritmissa tukkiosan
Rem pituus katkaistaan 0,3 m monikerroiksi.
Rem Toimenpiteen yhteisvaikutuksena tukkiosan pituus pyristyy
Rem lhimpn 0,3 m:n monikertaan.

1120 ero = hteor * AK(ntuk, ipl) - AL(ntuk, ipl) - 0.15

Rem Yksitukkisilla rungoilla tukkiosaa kasvatetaan korkeintaan 1 metri.

If (ntuk <= 1) Then
   If (ero > -1#) Then ero = ero: GoTo 1100
   If (ero <= -1#) Then ero = -1#: GoTo 1100
End If

Rem Koivuille asetetaan keskimrinen latvakuituun siirtyv osuus
Rem 1 metriksi

1130 ero = 1#
1100 eroest = ero

End Function

Function hkanio(ByVal ipl As Integer, ByVal d As Double, ByVal h As Double) As Double

Rem Funktio ennustaa juurenniskan korkeuden Ilvessalon mittojen avulla.

Static HKAN(1 To 6) As Double
Static dkan(1 To 6) As Double
Static indpuu(1 To 9)  As Integer

HKAN(1) = 0.00092874
HKAN(2) = 0.0056579
HKAN(3) = 0.0048152
HKAN(4) = 0.00011769
HKAN(5) = 0.0017146
HKAN(6) = 0.00805242

dkan(1) = 0.0045456
dkan(2) = 0.0051911
dkan(3) = 0.0051505
dkan(4) = 0.0072661
dkan(5) = 0.0075402
dkan(6) = 0.00107911

indpuu(1) = 1: indpuu(2) = 2: indpuu(3) = 3: indpuu(4) = 3: indpuu(5) = 4:
indpuu(6) = 5: indpuu(7) = 6: indpuu(8) = 1: indpuu(9) = 3

hkanio = HKAN(indpuu(ipl)) * h + dkan(indpuu(ipl)) * d
End Function

Sub polk(ByVal pit As Double, yhtpit As Double, npolk As Integer)

Rem Rungon osan plkyttminen plkytysparametrien mukaisesti
Rem PIT         on plkyttv pituus (eroest-funktion jlkeen)
Rem YHTPIT      on saatujen plkkyjen yhteispituus
Rem NPOLK       on saatujen plkkyjen lukumr

Rem ST-laadulle plkytysalgoritmi on sdetty EROEST-funktiolla mritetyn
Rem yhtenisen ST-osan pituuden mukaiseksi. Jos tukkiosan pituuden mrmist
Rem muutetaan, niin tllin on muutettava mys plkytysalgoritmia.

Rem Muille plkytettville laaduille mrtn plkkyjen lukumr
Rem minimipituuden avulla. Mahdollinen ylijm tasataan plkyille tyvest
Rem alkaen kasvattamalla tarpeellinen mr plkkyj maksimipituisiksi.

Rem Asettaa
Rem Ositus / NPOLK  <- saatujen plkkyjen lukumrn
Rem        / POLPIT <- saatujen plkkyjen pituudet

Rem Kutsutut aliohjelmat

ReDim polpit(1 To 10) As Double
Dim PMIN, PKES, pmax, vali, ppit, ero, del As Double


PMIN = 4.3
PKES = 4.9
pmax = 6.1


Rem Plkyn 1 alkuasetukset.
Rem ST laaduille 0-3 plkyn pituuden tulee olla 0.3 m:n monikertoja; muilla
Rem laaduilla 0,1 m:n monikertoja. Jakovli asetetaan tmn mukaisesti.

npolk = 0
yhtpit = 0#
vali = 0.3

Rem Plkky 2
Rem Tarkista tuleeko minimiplkky, mikli ST-laadusta ei tule parametrina annettua
Rem minimiplkky, niin siit yritetn lyhytt plkky yleisten lpimitta-
Rem vaatimusten mukaisesti.

If (pit >= PMIN) Then GoTo 3300
GoTo 9000

Rem Plkky 3
Rem Yhden plkyn normaalit rungon osat

3300 If (pit > pmax) Then GoTo 3400
npolk = 1
polpit(1) = pit - ((pit - 0.099) - Int((pit - 0.099) / vali) * vali) + 0.001
yhtpit = polpit(1)


GoTo 9000

Rem Plkky 4
Rem Usean plkyn rungon osat
Rem Mr plkkyjen lukumr sek plkyn pituus

3400 npolk = (pit / PKES) + 0.5

If (pit / npolk < PMIN) Then npolk = npolk - 1
If (pit / npolk < pmax) Then ppit = pit / npolk: GoTo 3401
If (pit / npolk > pmax) Then ppit = pmax: GoTo 3401

3401

ppit = ppit - (ppit - Int(ppit / vali) * vali) + 0.001


Rem Plkky 5
Rem Tasaa ylijm tyvest alkaen kasvattamalla plkyt
Rem maksimipituisiksi, jos tarpeen

ero = pit - npolk * ppit
ero = ero - ((ero + 0.001) - Int((ero + 0.001) / vali) * vali) + 0.001



For i = 1 To npolk
  del = 0#
     If (ero > 0) Then
     If ((pmax - ppit) <= ero) Then del = (pmax - ppit): GoTo 3403
     If ((pmax - ppit) > ero) Then del = ero: GoTo 3403
     End If

3403 polpit(i) = ppit + del
     ero = ero - del
     yhtpit = yhtpit + polpit(i)
     
  Next i

9000 End Sub

